



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>WebRTC手记之本地视频采集</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">WebRTC手记之本地视频采集</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 03:02:29 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>转载请注明出处：<a href="http://www.cnblogs.com/fangkm/p/4374610.html" rel="external nofollow noreferrer">http://www.cnblogs.com/fangkm/p/4374610.html</a></p>
<p>前面两篇文章介绍WebRTC的运行流程和使用框架接口，接下来就开始分析本地音视频的采集流程。由于篇幅较大，视频采集和音频采集分成两篇博文，这里先分析视频采集流程。分析的时候先分析WebRTC原生的视频采集流程，再捎带提一下Chromium对WebRTC视频采集的适配，这样能更好地理解WebRTC的接口设计。</p>
<h2>1. WebRTC原生视频采集</h2>
<p>在介绍视频设备的采集之前，首先要分析一下WebRTC的DeviceManager结构，因为视频采集的抽象接口VideoCapturer的WebRTC原生实现就是通过它来创建的。这个类的功能还包括枚举音视频设备的相关信息等。结构如下：</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog2015/57211/201503/281810292554678.png" /></p>
<p>限于篇幅，该UML中没有标出DeviceManagerInterface接口的所有功能接口，具体包括：获取音频输入/输出设备列表、获取视频输入设备列表、根据设备信息创建VideoCapturer视频采集对象等。由于获取硬件设备列表，涉及到平台相关的调用，在Windows平台下的实现是Win32DeviceManager类（可以调用DeviceManagerFactory的静态方法Create()返回当前平台相应的DeviceManager对象）。关注一下DeviceWatcher，顾名思义，它的功能在于监控设备的变化。在Windows平台下的实现Win32DeviceWatcher通过API函数RegisterDeviceNotification监控视频类设备和音频类设备的变化。当有监视的类型设备发送变化时，会通过DeviceManagerInterface接口的SignalDevicesChange信号向外投递通知。最后分析一下创建VideoCapturer的流程。DeviceManager创建VideoCapturer对象时通过VideoDeviceCapturerFactory接口来完成的。VideoDeviceCapturerFactory接口的默认实现是WebRtcVideoDeviceCapturerFactory类，该类创建WebRtcVideoCapturer对象做为VideoCapturer接口的实现。可以理解成WebRtcVideoCapturer就是WebRTC原生的视频采集的实现，但这种说法不确切，因为视频采集涉及到跨平台，没这么简单。下面再细扒一下WebRtcVideoCapturer：</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog2015/57211/201503/281811353952785.png" /></p>
<p>由于平台相关性，WebRtcVideoCapturer仍然不是视频采集的真正实现，它创建一个VideoCaptureModule接口对象来完成真正的视频采集工作。该抽象接口是视频采集的实现接口，最终在Windows平台下由VideoCaptureDS（传统的DirectShow方式）和VideoCaptureMF（Vista之后的Media Foundation API实现方式）来实现采集工作。这里要说明一下VideoCaptureMF在WebRTC中还是个空架子，还未真正实现，如果读者对Media Foundation API实现视频采集感兴趣，可以参考Chromium的media库中VideoCaptureDeviceMFWin类实现。</p>
<p>接下来分析一下VideoSourceInterface和VideoCapturer是如何结合，以及采集由谁驱动开始的。</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog2015/57211/201503/281813320526656.png" /></p>
<p>VideoSource是WebRTC对VideoSourceInterface接口的实现, 它容纳一个VideoCapturer对象做为视频采集源，VideoRenderer是供外部从VideoSource中获取视频帧数据。此外VideoSource还依赖ChannelManager对象，使用它所包含的CaptureManager来负责视频的采集任务。VideoSource在创建的时候就会调用 Initialize方法中调用ChannelManager的StartVideoCapture方法开始采集视频数据。CaptureManager内部为每个VideoCapturer对象维护了一个CaptureRenderAdapter，CaptureRenderAdapter在创建的时候将OnVideoFrame成员方法挂接上VideoCapturer的SignalVideoFrame信号来实时接收采集源传送过来的视频帧数据，OnVideoFrame内部将接收到的视频帧数据分发给向其注册的VideoRenderer对象（VideoRenderer对象的注册的流程是VideoSource到ChannelManager，再到CaptureManager，最后注册到CaptureRenderAdapter与特定的VideoCapturer关联）。</p>
<p>至此，VideoSourceInterface在WebRTC中的实现已经很清晰了，视频采集的流程和时机也很明了，接下来顺便稍等地简单分析一下WebRTC中VideoTrackInterface接口的实现：</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog2015/57211/201503/281814144586945.png" /></p>
<p>WebRTC创建了一个VideoTrack实现VideoTrackInterface接口，在此之前我一直有个疑问，VideoTrackInterface对外暴露的视频输出接口是VideoRendererInterface，而视频源接口VideoSourceInterface对外暴露的视频输出接口是VideoRenderer，两套接口是如何适配的。看到这里，我发现原来VideoTrack新建了一个VideoTrackRenderers对象来完成VideoRendererInterface接口到VideoRenderer接口的适配工作。VideoTrackRenderers一方面从VideoRenderer接口派生，这样就可以将自己通过VideoSourceInterface的AddSink方法挂接进去来接收视频帧数据，另一方面将接收到的视频帧数据分发给外部挂接给VideoTrackInterface的VideoRendererInterface接口。</p>
<h2>2. Chromium对WebRTC的视频采集适配</h2>
<p>Chromium创建WebRtcVideoCapturerAdapter类来实现VideoCapturer接口，相关结构如下：</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog2015/57211/201503/281824503335175.png" /></p>
<p>Chromium自己也封装了Track、Source概念，所以当初看这块的时候脑袋不容易转弯费了不少心思。WebRtcVideoCapturerAdapter需要接收Chromium的视频采集模块传输过来的帧数据，通过一层层的挂接，最终挂接到MediaStreamVideoSource类中。MediaStreamVideoSource接收到视频帧数据时，再一层层地通知回来，最终通知到WebRtcVideoCapturerAdapter的OnFrameCaptured方法，该方法内部触发SignalFrameCaptured信号。</p>
<p>MediaStreamVideoSource封装了Chromium视频采集的入口，这块结构就复杂了，牵涉到跨进程的架构，如下：</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog2015/57211/201503/281825221617399.png" /></p>
<p>这部分不打算细说，如果细说就很可能混淆到目前为止建立的仅有的一点点概念了，本节主要是介绍的是Chromium对WebRTC视频采集接口的定制。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8z6v1qy.html">Maven实战：pom&period;xml与settings&period;xml</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwjj7k8.html">耿丹CS16-2班课堂测试作业汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy4vmdq.html">Model View</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8elz4xq.html">Vmware  vsphere webservice sdk 连接打开慢的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xxvnz8.html">CentOS下更新python版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e10e4k9.html">Multi-catch</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydrjwjq.html">&lpar;转&rpar;MongoDB分片实战  集群搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnxmx08.html">javaSE-基础部分整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o6eny9.html">parquet code demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/8memmgrq.html">javascript中处理引号编码&amp;amp&semi;&num;034&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpno469.html">Cocos2dx 3&period;1&period;1 学习笔记整理&lpar;3&rpar;：逐帧动画</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mp2dn8.html">「七天自制PHP框架」第二天：模型与数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjr2yl8.html">Analog&sol;digital converter &lpar;ADC&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m1r348.html">python 3&period;6 tkinter&plus;urllib&plus;json 火车车次信息查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgp2vd8.html">PHP 常用header头定义</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pergj8.html">sigaction 的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25m1mlq.html">antd card 组件实现鼠标移入移出效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv50p28.html">Java&plus;selenium之WebDriver对浏览器的简单操作&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjg52l9.html">&lbrack;Day14&rsqb;Eclipse高级、类与接口作为参数返回值</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1xzme9.html">Mac上安装pipenv时报错</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/o8o7vppq.html">PE刷题记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx15de9.html">《ASP&period;NET1200例》&amp;lt&semi;asp&colon;DataList&amp;gt&semi;分页显示图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pz3ld8.html">python下的MySQLdb使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1elgz9.html">c&sol;c&plus;&plus;指针总结&lbrack;pointer summary&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/m961zz48.html">Java性能优化权威指南-读书笔记（五）-JVM性能调优-吞吐量</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn3lng9.html">CSS备忘</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdmx5zq.html">iftop安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jkgml8.html">学习hadoop，搭建hadoop遇到一些特殊问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2rv3l9.html">php  用封装类的方法操作数据库和批量删除</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4xwve8.html">Android文件Apk下载变ZIP压缩包解决方案</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
